const fs = require('fs');
const path = require('path');


class BASCII {

	constructor(font) {
		let file;
		if(fs.existsSync(font))
			file = font;
		else {
			file = path.join(__dirname,'fonts',`${font}.flf`);
		}
		let flf = fs.readFileSync(file).toString();
		let lines = flf.split('\n');
		let info = lines.shift();
		info = info.match(/(\S+)\s(\S+)\s(\S+)\s(\S+)\s(\S+)\s(\S+)/);
		info.shift();
		let ident = info.shift();
		let [ height, ndch, llen, sm, skip ] = info.map(n => parseInt(n));
		this.height = height;
		while(skip--)
			lines.shift();
		this.font = lines.join('\n')
						.split('@@\n')
						.map(c => 
							c.replace(/\$/g,' ')
							.replace(/@/g,'')
							.split('\n')
						);
	}

	get(text) {
		let l = new Array(this.height).fill('');
		let chars = text.toUpperCase().split('').map((ch) => {
			let seq = ch.charCodeAt(0) - 32;
			if(seq > this.font.length)
				seq = 0;
			return this.font[seq].slice();
		}).forEach((ch) => {
			let i = 0;
			while(ch.length) {
				l[i++] += ch.shift();
			}
		});

		return l.join('\n');
	}

	print(text) {
		console.log(this.get(text))
	}
}

module.exports = BASCII;
